# Generated by Django 2.2.18 on 2021-10-22 15:55

from django.db import migrations, models
import django.db.models.deletion
import shuup.core.fields


def migrate_vendor_revenue_lines(apps, schema_editor):
    """Transfer normal VendorOrderLineRevenue records to Canvas' version."""

    VendorOrderLineRevenue = apps.get_model("shuup_multivendor.VendorOrderLineRevenue")
    CanvasVendorLineRevenue = apps.get_model("canvas.CanvasVendorLineRevenue")

    all_revenue_lines = VendorOrderLineRevenue.objects.all()
    revenue_lines = [
        {
            "shop": line.shop,
            "order_line": line.order_line,
            "percentage": line.percentage,
            "revenue_value": line.revenue_value,
        }
        for line
        in all_revenue_lines
    ]
    canvas_revenue_lines = [CanvasVendorLineRevenue(**kwargs) for kwargs in revenue_lines]
    CanvasVendorLineRevenue.objects.bulk_create(canvas_revenue_lines)
    all_revenue_lines.delete()


def reverse_migrate_vendor_revenue_lines(apps, schema_editor):
    VendorOrderLineRevenue = apps.get_model("shuup_multivendor.VendorOrderLineRevenue")
    CanvasVendorLineRevenue = apps.get_model("canvas.CanvasVendorLineRevenue")

    canvas_revenue_lines = [
        {
            "shop": line.shop,
            "order_line": line.order_line,
            "percentage": line.percentage,
            "revenue_value": line.revenue_value,
        }
        for line
        in CanvasVendorLineRevenue.objects.all()
    ]
    revenue_lines = [VendorOrderLineRevenue(**kwargs) for kwargs in canvas_revenue_lines]
    VendorOrderLineRevenue.objects.bulk_create(revenue_lines)


class Migration(migrations.Migration):

    dependencies = [
        ('shuup', '0093_fix_attr_m2m'),
        ('canvas', '0020_store_purchases'),
        ('shuup_multivendor', '0025_update_staff_permissions'),
    ]

    operations = [
        migrations.CreateModel(
            name='CanvasVendorLineRevenue',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('percentage', models.DecimalField(decimal_places=2, max_digits=5, verbose_name='percentage')),
                ('revenue_value', shuup.core.fields.MoneyValueField(decimal_places=9, default=0, editable=False, max_digits=36, verbose_name='funds')),
                ('order_line', models.OneToOneField(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='online_vendor_revenue_percentage', to='shuup.OrderLine', verbose_name='order line')),
                ('purchase_line', models.OneToOneField(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='pos_vendor_revenue_percentage', to='canvas.StorePurchaseLine', verbose_name='store purchase line')),
                ('shop', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='canvas_vendor_revenue', to='shuup.Shop')),
            ],
        ),
        migrations.RunPython(migrate_vendor_revenue_lines, reverse_migrate_vendor_revenue_lines)
    ]
